!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2005, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine BasicEnv
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: basicenv.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

subroutine BasicEnv()
  !
  !ǥեȤδܾꤹ뤿Υ֥롼. 
  !ܾ׻, BasicSet ⥸塼ͤ. 
  !
  !ѥν꤫, ܾ(hogeBasicZ ѿ)
  !׻ʬBasicSet ⥸塼뤫ڤΥƤ. 
  !ECCM Ϥ, BasicSet Τ˰¸뤬 hogeBasicZ  use ʤ
  !֥롼Ѥ뤿Ǥ. 
  !

  !⥸塼ɤ߹
  use gridset,  only: DimXMin,       &! X β
    &                 DimXMax,       &! X ξ
    &                 DimZMin,       &! Z β
    &                 DimZMax,       &! Z ξ
    &                 SpcNum,        &!Žʬο
    &                 s_Z,           &!顼ʻǤι
    &                 DelZ            !Z γʻֳ
  use basicset, only: BasicSetArray_Init, &!
    &                 PressSfc,      &!ʬ갵Ǯ  
    &                 GasRDry,       &!ʬ갵Ǯ
    &                 CpDry,         &!ʬ갵Ǯ
    &                 CvDry,         &!ʬǮ
    &                 MolWtDry,      &!ʬʬ
    &                 Grav,          &!ϲ®
    &                 SpcWetMolFr,   &!Žʬν
    &                 MolWtWet,      &!Žʬʬ
    &                 EnvType,       &!ܾ
    &                 Tropopause,    &!ή̹
    &                 Humidity        !ܾм
  use Boundary, only: xz_Boundary_Cyc_Sym 
  use MoistFunc,only: xz_MolFr2MixRt
  use ECCM,     only: ECCM_Init,     &!
    &                 ECCM_Temp_Press, &!
    &                 ECCM_MolFr
  
  !ۤηػ
  implicit none

  !ѿ
  real(8) :: xz_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PressBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_TempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8) :: xz_MixRtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
  real(8) :: xz_EffMolWtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)

  real(8) :: MolFrIni(SpcNum)
  real(8) :: xz_MolFr(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
  real(8) :: xz_MixRtDivMolWt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
  integer :: i, k, s

  !---------------------------------------------------------------
  ! ν
  !---------------------------------------------------------------
  xz_DensBasicZ     = 0.0d0
  xz_PressBasicZ    = 0.0d0
  xz_ExnerBasicZ    = 0.0d0
  xz_TempBasicZ     = 0.0d0
  xz_PotTempBasicZ  = 0.0d0
  xz_VelSoundBasicZ = 0.0d0
  xz_MixRtBasicZ    = 0.0d0
  xz_EffMolWtBasicZ = 0.0d0

  !---------------------------------------------------------------
  ! ECCM ⥸塼ν
  !---------------------------------------------------------------
  call ECCM_Init
       
  !---------------------------------------------------------------
  ! EnvType 򸵤, , , 
  !---------------------------------------------------------------
  if (trim(EnvType) == 'Dry') then 
    MolFrIni = 0.0d0
  elseif (trim(EnvType) == 'Moist') then 
    MolFrIni = SpcWetMolFr(1:SpcNum) 
  end if
 
  do i = DimXMin, DimXMax
    call ECCM_Temp_Press( MolFrIni, xz_TempBasicZ(i,:), xz_PressBasicZ(i,:) ) 
  end do
  
  ! ή̤ΰ
  do k = DimZMin, DimZMax      
    if (s_Z(k) > Tropopause) then 
      xz_TempBasicZ(:,k) = xz_TempBasicZ(:,k-1) 
      xz_PressBasicZ(:,k) = &
        & xz_PressBasicZ(:,k-1) &
        &   * dexp( - DelZ * Grav / (GasRDry * xz_TempBasicZ(:,k)) ) 
    end if
  end do
  
  !
  xz_TempBasicZ = xz_Boundary_Cyc_Sym(xz_TempBasicZ)
  xz_PressBasicZ = xz_Boundary_Cyc_Sym(xz_PressBasicZ)
  
  !---------------------------------------------------------------
  ! 
  !---------------------------------------------------------------
  do i = DimXMin, DimXMax      
    call ECCM_MolFr( SpcWetMolFr(1:SpcNum) * Humidity, Humidity, xz_TempBasicZ(i,:), &
      &              xz_PressBasicZ(i,:), xz_MolFr(i,:,:) )
  end do
    
  !Υ򺮹Ѵ
  do s = 1, SpcNum
    xz_MixRtBasicZ(:,:,s) = xz_MolFr2MixRt(MolWtWet(s), xz_MolFr(:,:,s))
  end do

  !ͤʤꤹʤ褦˺ͤͿ
!  where (xz_MixRtBasicZ <= 1.0d-20 )
!    xz_MixRtBasicZ = 1.0d-20
!  end where
  
  !
  do s = 1, SpcNum
    xz_MixRtBasicZ(:,:,s) = xz_Boundary_Cyc_Sym(xz_MixRtBasicZ(:,:,s))
  end do

      
  !---------------------------------------------------------------
  ! ʬ̤θ
  !---------------------------------------------------------------
  do s = 1, SpcNum
    xz_MixRtDivMolWt(:,:,s) = xz_MixRtBasicZ(:,:,s) / MolWtWet(s)
  end do
  
  xz_EffMolWtBasicZ = &
    & 1.0d0 -  sum(xz_MixRtDivMolWt,3) &
    &            / ((1.0d0 / MolWtDry) + sum(xz_MixRtDivMolWt,3))  &
    & * (1.0d0 + sum(xz_MixRtBasicZ,3) )
  
  xz_EffMolWtBasicZ = xz_Boundary_Cyc_Sym(xz_EffMolWtBasicZ)
      
  
  !---------------------------------------------------------------    
  ! 
  !---------------------------------------------------------------
  xz_PotTempBasicZ = &
    & xz_TempBasicZ * (PressSfc / xz_PressBasicZ) ** (GasRDry / CpDry) 
  xz_PotTempBasicZ = xz_Boundary_Cyc_Sym(xz_PotTempBasicZ)

  
  !---------------------------------------------------------------    
  ! ʡؿ
  !---------------------------------------------------------------
  xz_ExnerBasicZ = xz_TempBasicZ / xz_PotTempBasicZ    
  xz_ExnerBasicZ = xz_Boundary_Cyc_Sym(xz_ExnerBasicZ)

  
  !---------------------------------------------------------------    
  ! ̩
  !---------------------------------------------------------------
  xz_DensBasicZ = &
    & PressSfc * (xz_ExnerBasicZ ** (CvDry / GasRDry)) &
    &  / (GasRDry * xz_PotTempBasicZ / xz_EffMolWtBasicZ)
  xz_DensBasicZ = xz_Boundary_Cyc_Sym(xz_DensBasicZ)
  

  !---------------------------------------------------------------    
  ! ®
  !---------------------------------------------------------------
  xz_VelSoundBasicZ = &
    & sqrt ( &
    &   CpDry * GasRDry * xz_ExnerBasicZ * xz_PotTempBasicZ &
    &   / (CvDry * xz_EffMolWtBasicZ) &
    & )
  xz_VelSoundBasicZ = xz_Boundary_Cyc_Sym(xz_VelSoundBasicZ)

 
  !----------------------------------------------------------
  ! BasicSet ⥸塼ͤ  
  !----------------------------------------------------------
  call BasicSetArray_Init(                                  &
    & xz_PressBasicZ,    xz_ExnerBasicZ, xz_TempBasicZ,     &
    & xz_PotTempBasicZ,  xz_DensBasicZ,  xz_VelSoundBasicZ, &
    & xz_MixRtBasicZ, xz_EffMolWtBasicZ )

end subroutine BasicEnv
